"use strict";

var __assign = this && this.__assign || function () {
    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = this && this.__metadata || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
    function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
            resolve(value);
        });
    }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = this && this.__generator || function (thisArg, body) {
    var _ = { label: 0, sent: function () {
            if (t[0] & 1) throw t[1];return t[1];
        }, trys: [], ops: [] },
        f,
        y,
        t,
        g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
        return this;
    }), g;
    function verb(n) {
        return function (v) {
            return step([n, v]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0:case 1:
                    t = op;break;
                case 4:
                    _.label++;return { value: op[1], done: false };
                case 5:
                    _.label++;y = op[1];op = [0];continue;
                case 7:
                    op = _.ops.pop();_.trys.pop();continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];t = op;break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];_.ops.push(op);break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [6, e];y = 0;
        } finally {
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decoratorTaskQueue = exports.TaskQueue = void 0;
var event_message_center_1 = require("event-message-center");
var TaskQueue = function () {
    function TaskQueue(_a) {
        var maxLen = _a.maxLen;
        var _this = this;
        this.fix = "@~&$";
        this.init = function () {
            _this.messageCenter.on("push:handler", _this.run);
            _this.messageCenter.on("run:success:handler", _this.run);
            _this.messageCenter.on("run:success:handler", _this.finish);
            _this.messageCenter.on("run:error:handler", _this.run);
        };
        this.push = function (queue) {
            _this.checkHandler(queue);
            var _a = _this.defer(),
                resolve = _a.resolve,
                reject = _a.reject,
                promise = _a.promise;
            var queueName = _this.fixStr(queue.name);
            _this.queues = _this.queues.concat(queue.children.map(function (i) {
                return __assign(__assign({}, i), { name: queueName });
            }));
            _this.queueTemp[queueName] = __assign(__assign({}, queue), { result: [] });
            _this.messageCenter.emit("push:handler", reject);
            _this.messageCenter.on(queueName, resolve);
            return promise;
        };
        this.unshift = function (length) {
            return _this.queues.splice(0, length);
        };
        this.run = function (reject) {
            return __awaiter(_this, void 0, void 0, function () {
                var queues, res, error_1;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.stateProxy() === 'pending') return [2, void 0];
                            if (this.queues.length === 0) return [2, this.stateProxy("idle")];
                            this.stateProxy("pending");
                            queues = this.unshift(this.maxLen);
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3,, 4]);
                            return [4, Promise.all(queues.map(function (i) {
                                return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                return [4, i.defer(i.params)];
                                            case 1:
                                                return [2, _a.sent()];
                                        }
                                    });
                                });
                            }))];
                        case 2:
                            res = _a.sent();
                            this.stateProxy("fulfilled");
                            return [2, this.messageCenter.emit("run:success:handler", { res: res, queues: queues })];
                        case 3:
                            error_1 = _a.sent();
                            this.stateProxy("rejected");
                            reject && typeof reject === "function" && reject(error_1);
                            return [2, this.messageCenter.emit("run:error:handler", error_1)];
                        case 4:
                            return [2];
                    }
                });
            });
        };
        this.clear = function () {
            _this.queues = [];
            _this.queueTemp = {};
            _this.stateProxy("idle");
            _this.messageCenter.clear();
        };
        this.finish = function (_a) {
            var res = _a.res,
                queues = _a.queues;
            var queueTemp = _this.queueTemp;
            queues.forEach(function (it, i) {
                var _a, _b;
                var item = queueTemp[it.name];
                item === null || item === void 0 ? void 0 : item.result.push(res[i]);
                if (((_a = item === null || item === void 0 ? void 0 : item.result) === null || _a === void 0 ? void 0 : _a.length) === ((_b = item === null || item === void 0 ? void 0 : item.children) === null || _b === void 0 ? void 0 : _b.length)) {
                    _this.messageCenter.emit(it.name, item === null || item === void 0 ? void 0 : item.result);
                    queueTemp[it.name] = null;
                }
            });
        };
        this.stateProxy = function (state) {
            state && (_this.state = state);
            return _this.state;
        };
        this.defer = function () {
            var resolve, reject;
            return {
                promise: new Promise(function (_resolve, _reject) {
                    resolve = _resolve;
                    reject = _reject;
                }),
                resolve: resolve,
                reject: reject
            };
        };
        this.maxLen = maxLen;
        this.clear();
        this.init();
    }
    TaskQueue.prototype.checkHandler = function (queue) {
        var _a, _b;
        if (!queue) {
            throw new ReferenceError('queue is not defined');
        }
        if (!(queue.children instanceof Array) || typeof queue !== "object") {
            throw new TypeError("queue should be an object and queue.children should be an array");
        }
        var noFn = function (i) {
            return !i.defer || typeof i.defer !== "function";
        };
        if (((_a = queue.children) === null || _a === void 0 ? void 0 : _a.length) === 0) throw new Error('queue.children.length can not be 0');
        if ((_b = queue.children) === null || _b === void 0 ? void 0 : _b.find(function (i) {
            return noFn(i);
        })) throw new Error('queueList should have defer');
    };
    TaskQueue.prototype.fixStr = function (str) {
        return "".concat(this.fix).concat(str);
    };
    TaskQueue = __decorate([event_message_center_1.decoratorMessageCenter, __metadata("design:paramtypes", [Object])], TaskQueue);
    return TaskQueue;
}();
exports.TaskQueue = TaskQueue;
var decoratorTaskQueue = function (opts) {
    return function (proto) {
        if (!proto.prototype.taskQueue) {
            proto.prototype.taskQueue = new TaskQueue(opts);
        }
    };
};
exports.decoratorTaskQueue = decoratorTaskQueue;
exports.default = TaskQueue;